ProtoType (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.types

## Class ProtoType

- java.lang.Object
- - hlt.language.design.types.Type
  - - hlt.language.design.types.ProtoType

- All Implemented Interfaces:
    Valuable

      public abstract class ProtoType
      extends Type

  All the methods redefined here are inherited from Type and are disabled in this class extension of `Type`.

  Note to myself: This class does not make any sense and BTW it is not used anywhere! For it to be of any utility, it should be extended by the `Type` class and used as a superclass of all classes that extend `Type` instead of `Type` (exactly in the same way the class `ProtoExpression` is defined as as subclass of `Expression` and extended by expression classes rather than `Expression`.

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.types.Type

      `ARRAY, BAG, BOOLEAN, BOXABLE, CHAR, CLASS, COLLECTION, CONSTANT, DEFINED, FUNCTION, INT, INT_RANGE, INT_SORT, LIST, NAMED_TUPLE, OBJECT_SORT, PARAMETER, REAL, REAL_RANGE, REAL_SORT, SET, STRING, TUPLE, VOID, VOID_SORT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ProtoType()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Type` | `baseType()` Returns the value of this when this does not have a base type; or that of its base type otherwise.
    `Type` | `baseTypeRef()` Returns this when this does not have a base type; or the (undereferenced) base type otherwise.
    `void` | `checkOccurrence(TypeParameter parameter, Type context, TypeChecker typeChecker)` Throws a `FailedUnificationException` if the specified type parameter occurs in this type.
    `Type` | `copy()` Returns a copy of this type with an empty renaming.
    `Type` | `copy(java.util.HashMap parameters)` Returns a copy of this type with a consistent renaming of all free type parameters, and identyfing bound type parameters with their values.
    `void` | `curry(int depth, TypeChecker typeChecker)` If this this a function type, transforms the type by splitting the domains at the specified depth, and records the old form in the appropriate trail of the specified type-checker for undoing purposes.
    `int` | `eqCode()` Returns a hash code for this type - the reason for using the name `eqCode` (rather than overriding `hashCode`), is that it is important to preserve the implementation of `java.lang.Object.hashCode` for type parameters (to be compatible with `==`).
    `boolean` | `equals(java.lang.Object object)`
    `Type` | `findValue()` This returns the type value this is bound to and side-effects the binding chains by shortening them (i.e., like the FIND operation of the UNION/FIND algorithm (returns itself by default - overridden by `TypeParameter`).
    `Type` | `flatten()` Returns a flattened form of this type by uncurrying all the domains of all function types that occur in it.
    `Type` | `instantiate(java.util.HashMap substitution)` Returns a copy of this type with all free type parameters bound as per the specified type substitution.
    `boolean` | `isBoxedType()` This returns `true` iff this type has been marked as boxed (`true` by default - overridden by `TypeConstant`).
    `boolean` | `isEqualTo(Type type)` Returns true iff this type is structurally isomorphic to the specified type.
    `boolean` | `isEqualTo(Type type, java.util.HashMap parameters)` Returns true iff this type is structurally isomorphic to the specified type, under the renaming of type parameters specified by the given HashMap.
    `boolean` | `isPolymorphic()`
    `byte` | `kind()` This returns the value identifying what kind of type this is.
    `int` | `numberOfTypeComponents()` Returns the number of type components making up this type.
    `Type` | `setBoxed(boolean flag)` With `true` (resp.
    `void` | `setTypeRefComponent(int n, Type type)` Sets the `n`-th undereferenced type component of this type to the specified type; throws a `NoSuchTypeComponentException` otherwise.
    `byte` | `sort()` This returns the runtime sort for this type (`OBJECT_SORT` by default - overridden by `TypeConstant`).
    `Type` | `typeRefComponent(int n)` Returns the `n`-th undereferenced type component in this type, if any; throws a `NoSuchTypeComponentException` otherwise.
    `boolean` | `unify(Type type)` This unifies this type with the specified type with no possibility of undoing any effects.
    `void` | `unify(Type type, TypeChecker typeChecker)` This unifies this type with the specified type in the context of the specified `TypeChecker`.

    - ### Methods inherited from class hlt.language.design.types.Type

      `actualType, array, array, BOOLEAN, BOXED_BOOLEAN, BOXED_CHAR, BOXED_INT, BOXED_REAL, boxSort, CHAR, getParameters, getParameters, getValue, INT, is, isBag, isBoolean, isChar, isCollection, isGlobalUnsafe, isInt, isList, isPrimitive, isReal, isSet, isString, isVoid, kindString, rank, REAL, resetNames, shadowType, standardize, toFullString, toQuantifiedString, toQuantifiedString, typeComponent, unwrapper, value, wrapper`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ProtoType

          public ProtoType()

  - ### Method Detail

    - #### numberOfTypeComponents

          public int numberOfTypeComponents()

      Description copied from class: `Type`
      Returns the number of type components making up this type.
      Specified by:
        `numberOfTypeComponents` in class `Type`

    - #### typeRefComponent

          public Type typeRefComponent(int n)
                                throws NoSuchTypeComponentException

      Description copied from class: `Type`
      Returns the `n`-th undereferenced type component in this type, if any; throws a `NoSuchTypeComponentException` otherwise.
      Specified by:
        `typeRefComponent` in class `Type`
      Throws:
        `NoSuchTypeComponentException`

    - #### setTypeRefComponent

          public void setTypeRefComponent(int n,
                                 Type type)
                                   throws NoSuchTypeComponentException

      Description copied from class: `Type`
      Sets the `n`-th undereferenced type component of this type to the specified type; throws a `NoSuchTypeComponentException` otherwise.
      Specified by:
        `setTypeRefComponent` in class `Type`
      Throws:
        `NoSuchTypeComponentException`

    - #### baseTypeRef

          public Type baseTypeRef()

      Description copied from class: `Type`
      Returns this when this does not have a base type; or the (undereferenced) base type otherwise.
      Overrides:
        `baseTypeRef` in class `Type`

    - #### baseType

          public Type baseType()

      Description copied from class: `Type`
      Returns the value of this when this does not have a base type; or that of its base type otherwise.
      Overrides:
        `baseType` in class `Type`

    - #### isPolymorphic

          public boolean isPolymorphic()

      Overrides:
        `isPolymorphic` in class `Type`

    - #### findValue

          public Type findValue()

      Description copied from class: `Type`
      This returns the type value this is bound to and side-effects the binding chains by shortening them (i.e., like the FIND operation of the UNION/FIND algorithm (returns itself by default - overridden by `TypeParameter`).
      Overrides:
        `findValue` in class `Type`

    - #### sort

          public byte sort()

      Description copied from class: `Type`
      This returns the runtime sort for this type (`OBJECT_SORT` by default - overridden by `TypeConstant`).

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `sort` in class `Type`

    - #### isBoxedType

          public boolean isBoxedType()

      Description copied from class: `Type`
      This returns `true` iff this type has been marked as boxed (`true` by default - overridden by `TypeConstant`).

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `isBoxedType` in class `Type`

    - #### setBoxed

          public Type setBoxed(boolean flag)

      Description copied from class: `Type`
      With `true` (resp. `false`), this marks this type as boxed (resp., unboxed), if it is boxable. Does nothing by default.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `setBoxed` in class `Type`

    - #### kind

          public byte kind()

      Description copied from class: `Type`
      This returns the value identifying what kind of type this is.
      Specified by:
        `kind` in class `Type`

    - #### unify

          public void unify(Type type,
                   TypeChecker typeChecker)
                     throws FailedUnificationException

      Description copied from class: `Type`
      This unifies this type with the specified type in the context of the specified `TypeChecker`.
      Specified by:
        `unify` in class `Type`
      Throws:
        `FailedUnificationException`

    - #### unify

          public boolean unify(Type type)

      Description copied from class: `Type`
      This unifies this type with the specified type with no possibility of undoing any effects. This method is meant to be used on types that are fresh copies independent of any type-checker because it will side-effect the structures it traverses. It returns `true` iff unification succeeds. NB: This method does not perform the "occurs-check" test.
      Specified by:
        `unify` in class `Type`

    - #### checkOccurrence

          public void checkOccurrence(TypeParameter parameter,
                             Type context,
                             TypeChecker typeChecker)
                               throws FailedUnificationException

      Description copied from class: `Type`
      Throws a `FailedUnificationException` if the specified type parameter occurs in this type. The type `context` is the outermost type enclosing this.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `checkOccurrence` in class `Type`
      Throws:
        `FailedUnificationException`

    - #### curry

          public void curry(int depth,
                   TypeChecker typeChecker)

      Description copied from class: `Type`
      If this this a function type, transforms the type by splitting the domains at the specified depth, and records the old form in the appropriate trail of the specified type-checker for undoing purposes. For example, currying A[1],...,A[n]n -> A at depth k (A[k+1],...,A[n] -> A). If this type is a type parameter, this will curry its value if any. Otherwise, does nothing.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `curry` in class `Type`

    - #### flatten

          public Type flatten()

      Description copied from class: `Type`
      Returns a flattened form of this type by uncurrying all the domains of all function types that occur in it. It also trims all binding chains of type parameters that may occur in it. The form returned is the canonical form used for all types of defined symbols and is assumed for type equality tests to work.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `flatten` in class `Type`

    - #### copy

          public Type copy(java.util.HashMap parameters)

      Description copied from class: `Type`
      Returns a copy of this type with a consistent renaming of all free type parameters, and identyfing bound type parameters with their values.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `copy` in class `Type`

    - #### copy

          public Type copy()

      Description copied from class: `Type`
      Returns a copy of this type with an empty renaming.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `copy` in class `Type`

    - #### instantiate

          public Type instantiate(java.util.HashMap substitution)

      Description copied from class: `Type`
      Returns a copy of this type with all free type parameters bound as per the specified type substitution.

      N.B.: The following definition specifies only the default behavior for this method. Specific subclasses are generally expected to override this method.

      Overrides:
        `instantiate` in class `Type`

    - #### eqCode

          public int eqCode()

      Description copied from class: `Type`
      Returns a hash code for this type - the reason for using the name `eqCode` (rather than overriding `hashCode`), is that it is important to preserve the implementation of `java.lang.Object.hashCode` for type parameters (to be compatible with `==`). All we require with this new code is that it be compatible with type equality as defined by `isEqualTo` - and it is! Incidentally, the same reason goes for preserving `equals` for type parameters to be compatible with `==` - and it is (see `TypeParameter`).
      Specified by:
        `eqCode` in class `Type`

    - #### equals

          public boolean equals(java.lang.Object object)

      Overrides:
        `equals` in class `Type`

    - #### isEqualTo

          public boolean isEqualTo(Type type)

      Description copied from class: `Type`
      Returns true iff this type is structurally isomorphic to the specified type. Two type parameters will be considered equal only if they are the same object (i.e., equal pointers).
      Specified by:
        `isEqualTo` in class `Type`

    - #### isEqualTo

          public boolean isEqualTo(Type type,
                          java.util.HashMap parameters)

      Description copied from class: `Type`
      Returns true iff this type is structurally isomorphic to the specified type, under the renaming of type parameters specified by the given HashMap.
      Specified by:
        `isEqualTo` in class `Type`